<?php
/* utf8-marker = äöüß */

/*
 * Repo_XH
 *
 * @author  Olaf Penschke    olape
 * @version 1.0 beta3 (30.04.2020)
 * @link    http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

================================================================================
*/
//******************************************************************************
// target (Cache) anzeigen mit Downloadlink und Reloadlink
function repoxh_list_cache($listformat = '') {

global $pth, $plugin_cf, $plugin_tx;

    $op_list_cache = '';
    $op_allfiles = scandir($pth['folder']['plugins'] . 'repoxh/target/');

    foreach($op_allfiles as $op_file_tmp) {
        if(($op_file_tmp != '.') 
        && ($op_file_tmp != '..') 
        && ($op_file_tmp != '.htaccess')) {
            if($listformat == 'full') {
                $op_list_cachetime = date('F d Y H:i:s', filemtime($pth['folder']['plugins']
                                   . 'repoxh/target/'
                                   . $op_file_tmp));
                $op_list_cache .= '<p>' . round((filesize($pth['folder']['plugins']
                               . 'repoxh/target/'
                               . $op_file_tmp) / 1024), 2)
                               . ' Kbyte';
                $op_list_cache .= ' -- ';
                $op_list_cache .= '<a target="_blank" href="'
                               . $pth['folder']['plugins']
                               . 'repoxh/download.php?download_csv='
                               . $op_file_tmp . '">' 
                               . $op_file_tmp . '</a>';
                $op_list_cache .= ' -- ';
                $op_list_cache .= $op_list_cachetime . ' (UTC) ';
                if(substr($op_file_tmp, -4) != '.bak') {
                    $op_list_cache .= ' -- <a target="_blank" href="'
                                   . $pth['folder']['plugins']
                                   . 'repoxh/xml2csv.php?repo_type=' 
                                   . substr($op_file_tmp, 0, -4)
                                   . '&repo_client=backend&repo_key='
                                   . $plugin_cf['repoxh']['secret_key'] . '">' 
                                   . $plugin_tx['repoxh']['backend_data_new'] . '</a>'
                                   . '</p>' . "\n";
                } else {
                    $op_list_cache .= '</p>' . "\n";
                }
            } else {
                $op_list_cache .= $op_file_tmp . ',';
            }
        }
    }
return $op_list_cache;
}
//******************************************************************************
// Change-Logs auslesen und anzeigen
function repoxh_list_changes() {

    global $pth, $plugin_tx;

    $op_list_changes = '';
    $op_allfiles = scandir($pth['folder']['plugins'] . 'repoxh/changes/');

    foreach($op_allfiles as $op_file_tmp) {
        if(($op_file_tmp != '.') 
        && ($op_file_tmp != '..') 
        && ($op_file_tmp != '.htaccess')) {
            $op_full_pth = $pth['folder']['plugins'] . 'repoxh/changes/' . $op_file_tmp;
            $op_list_changes .= '<h6>' . $op_file_tmp . '</h6>';
            $op_list_changes .= '<div class="repoxh_admin_change">';
            $op_list_changes_tmp = file_get_contents($op_full_pth);
            $op_list_changes .= nl2br($op_list_changes_tmp);
            $op_list_changes .= '</div>';
            // Form für das Leeren der Change-Logs
            $op_list_changes .= '<form action="?&repoxh&admin=plugin_data&action=plugin_text&normal" method="POST">';
            $op_list_changes .= '<input type="hidden" name="datafile" value="'
                             . $op_full_pth . '">';
            $op_list_changes .= '<input type="submit" name="file_delete" value="'
                             . $plugin_tx['repoxh']['backend_del_changes'] . '">';
            $op_list_changes .= '</form>';
        }
    }
return $op_list_changes;
}
//******************************************************************************
// Cron-Logs anzeigen mit Downloadlink
function repoxh_list_logs() {

global $pth;

    $op_list_logs = '';
    $op_allfiles = scandir($pth['folder']['plugins'] . 'repoxh/cronlogs/');

    foreach($op_allfiles as $op_file_tmp) {
        if(($op_file_tmp != '.') 
        && ($op_file_tmp != '..') 
        && ($op_file_tmp != '.htaccess')) {
            $op_list_logs .= '<p><a target="_blank" href="' 
                           . $pth['folder']['plugins'] 
                           . 'repoxh/download.php?download_log=' 
                           . $op_file_tmp . '">' 
                           . $op_file_tmp . '</a>'
                           . '</p>' . "\n";
        }
    }
return $op_list_logs;
}
//******************************************************************************
// Sources auslesen und anzeigen
function repoxh_list_sources() {

    global $pth, $plugin_cf, $plugin_tx;

    $op_list_sources = '';
    $op_allfiles = scandir($pth['folder']['plugins'] . 'repoxh/source/');

    foreach($op_allfiles as $op_file_tmp) {

        if(($op_file_tmp != '.') 
        && ($op_file_tmp != '..') 
        && ($op_file_tmp != '.htaccess') 
        && (substr($op_file_tmp, -4) != '.bak')) {
            $op_pth_tmp = $pth['folder']['plugins'] . 'repoxh/source/' . $op_file_tmp;
            $op_list_sources .= '<h6>' . $op_file_tmp . '</h6>' . "\n";
            // falls noch keine Zieldatei vorhanden Link zum Einlesen anzeigen
            $op_target_tmp = str_replace('.dat', '.csv', $op_file_tmp);
            $op_target_tmp = $pth['folder']['plugins'] . 'repoxh/target/' . $op_target_tmp;
            if(!file_exists($op_target_tmp)) {
                $op_list_sources .= '<a target="_blank" href="'
                                 . $pth['folder']['plugins']
                                 . 'repoxh/xml2csv.php?repo_type=' 
                                 . substr($op_file_tmp, 0, -4)
                                 . '&repo_client=backend&repo_key='
                                 . $plugin_cf['repoxh']['secret_key'] . '">' 
                                 . $plugin_tx['repoxh']['backend_data_new'] . '</a>'
                                 . "\n";
            }
            //
            // File im Lesemodus öffnen
            $fh = fopen($op_pth_tmp, 'r');
            $op_list_sources_tmp = fread($fh, filesize($op_pth_tmp));
            fclose($fh);
            // Form für das Speichern der dat's
            $op_list_sources .= '<form action="?&repoxh&admin=plugin_sources&action=plugin_text&normal" method="POST">';
            $op_list_sources .= '<input type="hidden" name="datafile" value="'
                             . $op_pth_tmp . '">';
            $op_list_sources .= '<textarea name="data">'
                             . $op_list_sources_tmp
                             . '</textarea>';
            $op_list_sources .= '<input type="submit" name="save_sources" value="'
                             . $plugin_tx['repoxh']['backend_save_sources']
                             . '">';
            $op_list_sources .= '</form>';
        }
    }
return $op_list_sources;
}
//******************************************************************************
?>