<?php
/* utf8-marker = äöüß */

/*
 * Repo_XH
 *
 * @author  Olaf Penschke    olape
 * Thanks to Frank Seidel (frase) for help
 * @version 1.0 beta3 (30.04.2020)
 * @link    http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

================================================================================
*/
if('repoxhfuncs.php' == basename($_SERVER['SCRIPT_FILENAME']))
{
    die('No direct access.');
}
//******************************************************************************
// Ausgabe als Tabelle
function repo_xh_table($repo_xh_cat = '', $repo_type = '') {

    global $pth, $su, $plugin_cf, $plugin_tx, $sl;

    if(function_exists('tablesorter')) {
        tablesorter();
    }
    //if(function_exists('fa_require')) {
    if(class_exists('Fa\\RequireCommand')) {
        fa_require();
    }

    $target_csv = $pth['folder']['plugins'] . 'repoxh/target/' . $repo_type . '.csv';
    $repo_xh_table_html = '<div class="repoxh_overview">' . "\n";

    if(file_exists($target_csv)) {
        // Filter ausgeben
        $repo_xh_table_html .= '<div class="repoxh_filter">' . "\n";
        $repo_xh_table_html .= '<p>' . $plugin_tx['repoxh']['cat_filters'] . '</p>' . "\n";
        if($repo_xh_cat == 'empty') {
            $activeCat = ' class="activeCat" ';
        } else {
            $activeCat = ' ';
        }
        if($su != '') {
            $repo_xh_table_html .= '<a'
                                . $activeCat
                                . 'href="?'
                                . $su
                                . '">'
                                . $plugin_tx['repoxh']['cat_all']
                                . '</a>'
                                . "\n";
        } else {
            $repo_xh_table_html .= '<a'
                                . $activeCat
                                . 'href="./">'
                                . $plugin_tx['repoxh']['cat_all']
                                . '</a>'
                                . "\n";
        }
        $repoxh_filter_tmp = trim($plugin_tx['repoxh'][$repo_type . '_cat_filter'], '| ');
        $repoxh_filter_array = explode('|', $repoxh_filter_tmp);
        sort($repoxh_filter_array);
        foreach($repoxh_filter_array as $repoxh_filter_tmp) {
            $repoxh_filter_tmp = trim($repoxh_filter_tmp);
            $repoxh_filter = explode('=', $repoxh_filter_tmp);
            $cat_filter_raw = trim($repoxh_filter[0]);
            $cat_filter_name = trim($repoxh_filter[1]);
            // for the translation of the categories in the table rows
            $cat_table_row_array[$cat_filter_raw] = $cat_filter_name;
            //
            if($repo_xh_cat == $cat_filter_raw) {
                $repo_xh_table_html .= '<a class="activeCat" href="?'
                                    . $su
                                    . '&repo_xh_cat='
                                    . $cat_filter_raw
                                    . '">'
                                    . $cat_filter_name
                                    . '</a>'
                                    . "\n";
            } else {
                $repo_xh_table_html .= '<a href="?'
                                    . $su
                                    . '&repo_xh_cat='
                                    . $cat_filter_raw
                                    . '">'
                                    . $cat_filter_name
                                    . '</a>'
                                    . "\n";
            }
        }
        unset($repoxh_filter_tmp);
        unset($repoxh_filter_array);
        unset($repoxh_filter);
        $repo_xh_table_html .= '</div>' . "\n";

        // Tabelle ausgeben
        $repo_xh_table_html .= '<div class="repoxh_table_out">' . "\n";
        $repo_xh_table_html .= '<table class="repoxh_table tablesorter">' . "\n";
        $repo_xh_table_html .= '<thead>' . "\n";
        $repo_xh_table_html .= '<tr>' . "\n";
        $repo_xh_table_html .= '<th>' . $plugin_tx['repoxh']['table_name'] . '</th>' 
                            . '<th>' . $plugin_tx['repoxh']['table_category'] . '</th>' 
                            . '<th>' . $plugin_tx['repoxh']['table_compatibility'] . '</th>' 
                            . '<th>' . $plugin_tx['repoxh']['table_license'] . '</th>';
        $repo_xh_table_html .= "\n" . '</tr>' . "\n";
        $repo_xh_table_html .= '</thead>' . "\n";

        $repo_xh_table_html .= '<tbody>' . "\n";
        $table_csv_row = [];
        // für alternative Ausgabe, falls Tabelle leer (Filter)
        $repo_xh_table_tr_count = 0;
        $table_csv = fopen ($target_csv,'r');
        // Datei zeilenweise auslesen, im Array $table_csv_row speichern
        //while(($table_csv_row = fgetcsv($table_csv)) !== FALSE ) {
        while(($table_csv_row = fgetcsv($table_csv, 0, ',', '"', "\x00")) !== false) {

            $teblad_id = $table_csv_row[0];
            $teblad_name = $table_csv_row[1];
            $teplad_coder = $table_csv_row[5];
            $teblad_cat = $table_csv_row[6];
            $teblad_compat = $table_csv_row[10];
            $teplad_license = $table_csv_row[12];

            // Ausgeben des Arrays $table_csv_row
            //if((strpos($teblad_cat, $repo_xh_cat) !== false) || ($repo_xh_cat == 'empty')) {
            if((stripos($teblad_cat, $repo_xh_cat) !== false) || ($repo_xh_cat == 'empty')) {
                // für alternative Ausgabe, falls Tabelle leer (Filter)
                $repo_xh_table_tr_count++;
                $repo_xh_table_html .= '<tr>' . "\n";
                $repo_xh_table_html .= '<td><a href="?'
                                    . $_SERVER['QUERY_STRING']
                                    . '&repo_xh_one='
                                    . $teblad_id
                                    . '" title="'
                                    . $plugin_tx['repoxh']['one_coder']
                                    . $teplad_coder
                                    .'">'
                                    . $teblad_name
                                    . '</a></td>';
//
                // xml - tags
                $repoxh_tags_array = explode(',', $teblad_cat);
                if($plugin_cf['repoxh']['sort_cat'] == 'on') {
                    sort($repoxh_tags_array);
                }
                $tags = '';
                foreach($repoxh_tags_array as $repoxh_tag) {
                    $repoxh_tag = trim($repoxh_tag);
                    // Übersetzung wenn möglich
                    if(isset($cat_table_row_array[$repoxh_tag])) {
                        $repoxh_tag = $cat_table_row_array[$repoxh_tag];
                    } elseif($sl != 'en') {
                        $repoxh_tag = ucfirst($repoxh_tag);
                    }
                    $tags .= $repoxh_tag . ', ';
                }
                $tags = rtrim($tags, ', ');
                $repo_xh_table_html .= '<td>' . $tags . '</td>';
                unset($repoxh_tag);
                unset($tags);
//
                $repo_xh_table_html .= '<td>' . $teblad_compat . '</td>';
                $repo_xh_table_html .= '<td>' . $teplad_license . '</td>';
                $repo_xh_table_html .= "\n" . '</tr>' . "\n";
            }
        }
        fclose($table_csv);
        $repo_xh_table_html .= '</tbody>' . "\n";
        $repo_xh_table_html .= '</table>' . "\n";
        $repo_xh_table_html .= '</div>' . "\n";
    }
    // alternative Ausgabe, falls Tabelle leer (Filter)
    if($repo_xh_table_tr_count === 0) {
        $repo_xh_table_html .= '<p class="no_match">'
                            . $plugin_tx['repoxh']['table_no_match']
                            . '</p>';
    }
    $repo_xh_table_html .= '</div>' . "\n";

return $repo_xh_table_html;
}
//******************************************************************************
// Ausgabe einzelnes Plugin / Template / AddOn
function repo_xh_one($repo_xh_one = '', $repo_type = '') {

    global $pth, $plugin_cf, $sl, $plugin_tx, $description, $cf, $tx;

    if(function_exists('fancybox')) {
        fancybox();
    }

    $logo_max_filesize = ($plugin_cf['repoxh']['logo_max_filesize'] * 1024);
    $screen_max_width = $plugin_cf['repoxh']['screen_max_width'];
    $screen_max_height = $plugin_cf['repoxh']['screen_max_height'];

    $target_csv = $pth['folder']['plugins'] . 'repoxh/target/' . $repo_type . '.csv';

    $repo_xh_one_html = '';

        $one_csv = fopen ($target_csv,'r');
        // Datei zeilenweise auslesen, fgetcsv() anwenden, im Array $one_csv_row speichern
        //while(($one_csv_row = fgetcsv($one_csv)) !== FALSE ) {
        // Ausgeben des Arrays $one_csv_row
        while(($one_csv_row = fgetcsv($one_csv, 0, ',', '"', "\x00")) !== false) {
//
            $teplad_id = $one_csv_row[0];
            $teplad_name = $one_csv_row[1];
            $teplad_last_upd = $one_csv_row[2];
            $teplad_cur_ver = $one_csv_row[3];
            $teplad_cur_d_publ = $one_csv_row[4];
            $teplad_coder = $one_csv_row[5];
            $teplad_tags = $one_csv_row[6];
            $teplad_down_url = $one_csv_row[7];
            $teplad_coder_site = $one_csv_row[8];
            $teplad_demo_url = $one_csv_row[9];
            $teplad_compat = $one_csv_row[10];
            $teplad_php_ver = $one_csv_row[11];
            $teplad_license = $one_csv_row[12];
            $teplad_logo = $one_csv_row[13];
            $teplad_desc_en = $one_csv_row[14];
//
            if($repo_xh_one == $teplad_id) {
                // Link zurück zur Übersicht
                $repo_xh_one_html .= repoxh_on_backlink();
                // Plugin Name
                $repo_xh_one_html .= '<h2 class="repoxh_on_name">'
                                  . $teplad_name
                                  . '</h2>'
                                  . "\n";
                // Meta-Title anpassen
                $op_tmp_SiteTitel = $tx['site']['title']
                                  . ' | '
                                  . ucfirst($repo_type)
                                  . ' | '
                                  . $teplad_name;
                $cf['site']['title'] = repoxh_Title($op_tmp_SiteTitel);
                $cf['title']['format'] = "{SITE}";
                repoxh_socTitle($cf['site']['title']);
//
                // Logo
                if(($teplad_logo) && ($teplad_logo != '')) {
                    $full_logo = $pth['folder']['plugins']
                               . 'repoxh/img_tmp/'
                               . $repo_type
                               . '/'
                               . $teplad_id
                               . '/'
                               . $teplad_logo;
                    if((file_exists($full_logo))
                    && (filesize($full_logo) <= $logo_max_filesize)) {
                        $repo_xh_one_html .= '<div class="repoxh_one_logo"><img src="'
                                          . $full_logo
                                          . '" alt="Logo '
                                          . $teplad_name
                                          . '" title="Logo '
                                          . $teplad_name
                                          . '"></div>';
                    }
                } else {
                    // Standardlogo, wenn in xml keins angegeben
                    $tmp_logo = $pth['folder']['plugins']
                              . 'repoxh/img/repo-logo-'
                              . $repo_type
                              . '.svg';
                    if(file_exists($tmp_logo)) {
                        $repo_xh_one_html .= '<div class="repoxh_one_logo"><img src="'
                                          . $tmp_logo
                                          . '" alt="'
                                          . ucfirst($repo_type)
                                          . ' Logo"></div>';
                    }
                }
//
                // Prüfen ab Element 14, ob Description in der gewählten Sprache verfügbar ist
                foreach($one_csv_row as $desc_count => $one_csv_row_desc) {
                    if($desc_count < 14) continue;
                    if(strpos($one_csv_row_desc, '|||||' . $sl . '|||||') !== false) {
                        $repo_xh_one_html .= '<h3 class="repoxh_one_phead">'
                                          . $plugin_tx['repoxh']['one_description']
                                          . '</h3>'
                                          . "\n";
                        $tmp_desc_sl = str_replace('|||||' . $sl . '|||||', '', $one_csv_row_desc);
                        $repo_xh_one_html .= '<div class="repoxh_one_desc">'
                                          . $tmp_desc_sl
                                          . '</div>'
                                          . "\n";
                        // Meta-Description anpassen
                        $description = repoxh_Description($tmp_desc_sl);
                        // Social-Media-Description anpassen
                        repoxh_socDesc($description);
                        $desc_found = 1;
                        break 1;
                    }
                }
                unset($desc_count);
                unset($one_csv_row_desc);
//
                // fallback falls Sprache nicht verfügbar
                if((!isset($desc_found)) && ($teplad_desc_en != '')) {
                    $repo_xh_one_html .= '<h3 class="repoxh_one_phead">'
                                      . $plugin_tx['repoxh']['one_description']
                                      . '</h3>'
                                      . "\n";
                    $tmp_desc_en = str_replace('|||||en|||||', '', $teplad_desc_en);
                    $repo_xh_one_html .= '<div class="repoxh_one_desc">'
                                      . $tmp_desc_en
                                      . '</div>'
                                      . "\n";
                    // Meta-Description anpassen
                    $description = repoxh_Description($tmp_desc_en);
                    // Social-Media-Description anpassen
                    repoxh_socDesc($description);
                }
                unset($desc_found);
//
                // falls keine Screenshots vorhanden
                $repo_xh_one_html_tmp = '';
                $screen_counter_tmp = 0;
                // Prüfen ab Element 14, ob Screenshots vorhanden sind
                foreach($one_csv_row as $screen_count => $one_csv_row_screen) {
                    if ($screen_count < 14) continue;
                    if(strpos($one_csv_row_screen, '|||||screenshot|||||') !== false) {
                        $one_csv_row_screen = trim($one_csv_row_screen);
                        $screen_link_alt = str_replace('|||||screenshot|||||', '', $one_csv_row_screen);
                        $screen_link_alt_array = explode('#####', $screen_link_alt);
                        $full_screen = $screen_link_alt_array[0];
                        $thumb_alt = $screen_link_alt_array[1];
                        $full_screen = $pth['folder']['plugins']
                                     . 'repoxh/img_tmp/'
                                     . $repo_type
                                     . '/'
                                     . $teplad_id
                                     . '/'
                                     . $full_screen;
                        $thumb_screen = str_replace('screenshot_',
                                                    'thumb_screenshot_',
                                                    $full_screen);
                        $full_screen_fullpth = __DIR__
                                             . '/img_tmp/'
                                             . $repo_type
                                             . '/'
                                             . $teplad_id
                                             . '/'
                                             . $screen_link_alt_array[0];
                        $thumb_screen_fullpth = str_replace('screenshot_',
                                                            'thumb_screenshot_',
                                                            $full_screen_fullpth);
//
                        // thumb wird erst bei Aufruf erstellt
                        if(!file_exists($thumb_screen)) {
                            repoxh_thumb($full_screen_fullpth,
                                         $thumb_screen_fullpth,
                                         $screen_max_width,
                                         $screen_max_height);
                            $screen_counter_tmp++;
                        }
                        if(file_exists($thumb_screen)) {
                            $repo_xh_one_html_tmp .= '<a title="' . $thumb_alt . '" class="zoom_g" href="' 
                                                   . $full_screen . '"><img src="' . $thumb_screen 
                                                   . '" alt="' . $thumb_alt . '"></a>';
                        }
                    }
                }
                // sind Screenshots vorhanden?
                if($repo_xh_one_html_tmp != '') {
                    $repo_xh_one_html .= '<h3 class="repoxh_one_phead">Screenshots</h3>' . "\n";
                    $repo_xh_one_html .= '<div class="repoxh_one_screen">';
                    $repo_xh_one_html .= $repo_xh_one_html_tmp;
                    $repo_xh_one_html .= '</div>' . "\n";
                }
                // 1/2 Sekunde, um sicheren ersten Zugriff auf neu erstellte Bilder zu bekommen,
                // ohne funktioniert es teilweise nicht
                if($screen_counter_tmp > 0) {
                    usleep(500000);
                }
                unset($screen_count);
                unset($one_csv_row_screen);
                unset($repo_xh_one_html_tmp);
                unset($screen_counter_tmp);
                //frase: Demo und Download erhalten eigene CSS-Klassen und eigene DIVs
                if(($teplad_demo_url) && ($teplad_demo_url != '')) {
                    if(substr($teplad_demo_url, 0, 4) === 'http') {
                        $repo_xh_one_html .= '<div class="oneDemoUrl">';
                        $repo_xh_one_html .= repoxh_url_link($teplad_demo_url,
                                                             $plugin_tx['repoxh']['one_demo_url'],
                                                             'dwnBtn repoBtn');
                        $repo_xh_one_html .= '</div>' . "\n";
                    }
                }
                if(($teplad_down_url) && ($teplad_down_url != '')) {
                    if(substr($teplad_down_url, 0, 4) === 'http') {
                        $repo_xh_one_html .= '<div class="oneDownloadUrl">';
                        $repo_xh_one_html .= repoxh_url_link($teplad_down_url,
                                                             $plugin_tx['repoxh']['one_download_url'],
                                                             'dwnBtn repoBtn');
                        $repo_xh_one_html .= '</div>' . "\n";
                    }
                }
                //frase: Liste verschoben nach unten
                //frase: Reihenfolge der li verändert
                $repo_xh_one_html .= '<ul class="repoxh_one_list">' . "\n";
                if(($teplad_tags) && ($teplad_tags != '')) {
                    $repoxh_tags_array = explode(',', $teplad_tags);
                    if($plugin_cf['repoxh']['sort_cat'] == 'on') {
                        sort($repoxh_tags_array);
                    }
                    $tags = '';
                    foreach($repoxh_tags_array as $repoxh_tag) {
                        $repoxh_tag = trim($repoxh_tag);
                        $repoxh_tag = ucfirst($repoxh_tag);
                        $tags .= $repoxh_tag . ', ';
                    }
                    $tags = rtrim($tags, ', ');
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_category']
                                      . '</span>'
                                      . $tags .
                                      '</li>'
                                      . "\n";
                    unset($repoxh_tag);
                    unset($tags);
                }
                if(($teplad_cur_ver) && ($teplad_cur_ver != '')) {
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_current_version']
                                      . '</span>'
                                      . $teplad_cur_ver
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_cur_d_publ) && ($teplad_cur_d_publ != '')) {
                    $current_date_publication = repoxh_input2date($teplad_cur_d_publ);
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_current_date_publication']
                                      . '</span>'
                                      . $current_date_publication
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_compat) && ($teplad_compat != '')) {
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_compatibility']
                                      . '</span>'
                                      . $teplad_compat
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_php_ver) && ($teplad_php_ver != '')) {
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_php_version']
                                      . '</span>'
                                      . $teplad_php_ver
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_license) && ($teplad_license != '')) {
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_license']
                                      . '</span>'
                                      . $teplad_license
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_coder) && ($teplad_coder != '')) {
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_coder']
                                      . '</span>'
                                      . $teplad_coder
                                      . '</li>'
                                      . "\n";
                }
                if(($teplad_coder_site) && ($teplad_coder_site != '')) {
                    if(substr($teplad_coder_site, 0, 4) === 'http') {
                        $repo_xh_one_html .= '<li><span>'
                                          . $plugin_tx['repoxh']['one_coder_website']
                                          . '</span>';
                        $repo_xh_one_html .= repoxh_url_link($teplad_coder_site);
                        $repo_xh_one_html .= '</li>' . "\n";
                    }
                }
                if(($teplad_last_upd) && ($teplad_last_upd != '')) {
                    $last_updated = repoxh_input2date($teplad_last_upd);
                    $repo_xh_one_html .= '<li><span>'
                                      . $plugin_tx['repoxh']['one_last_updated']
                                      . '</span>'
                                      . $last_updated
                                      . '</li>'
                                      . "\n";
                repoxh_socTimestamp($last_updated);
                }
                $repo_xh_one_html .= '</ul>' . "\n";
//
                // Link zurück zur Übersicht
                $repo_xh_one_html .= repoxh_on_backlink();
            }
        }

return $repo_xh_one_html;
}
//******************************************************************************
// Bilder auf passende Höhe und Breite verkleinern (Nur .jpg, .png und .gif)
function repoxh_thumb($image, $target, $max_width, $max_height) {

    $picsize = getimagesize($image);
    if(($picsize[2] == 1) || ($picsize[2] == 2) || ($picsize[2] == 3)) {
        if($picsize[2] == 1) {
            $src_img = imagecreatefromgif($image);
        }
        if($picsize[2] == 2) {
            $quality = 100;
            $src_img = imagecreatefromjpeg($image);
        }
        if($picsize[2] == 3) {
            $quality = 9;
            $src_img = imagecreatefrompng($image);
        }
        // Bildgrösse auslesen (https://cmsimpleforum.com/viewtopic.php?f=2&t=14473&start=120#p70101)
        //$src_width = $picsize[0];
        $src_width = imagesx($src_img);
        //$src_height = $picsize[1];
        $src_height = imagesy($src_img);

        // Skalierung berechnen und Vergrössern verhindern
        $skal_vert = $max_height/$src_height;
        $skal_hor = $max_width/$src_width;
        $skal = min($skal_vert, $skal_hor);
        if($skal > 1) {
            $skal = 1;
        }
        // Bearbeiten ist nicht notwendig, nur kopieren
        if($skal === 1) {
            copy($image, $target);
            return;
        }
        // Bildgrösse berechnen
        $dest_height = $src_height*$skal;
        $dest_width = $src_width*$skal;

        $dst_img = imagecreatetruecolor($dest_width,$dest_height);
        imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0,
                           $dest_width, $dest_height, $src_width, $src_height);
        // gif erstelen
        if($picsize[2] == 1) {
            imagegif($dst_img, "$target");
        }
        // jpg erstellen
        if($picsize[2] == 2) {
            imagejpeg($dst_img, "$target", $quality);
        }
        // png erstellen
        if($picsize[2] == 3) {
            imagepng($dst_img, "$target", $quality);
        }
    }
}
//******************************************************************************
// URLs bearbeiten, Linktext kürzen
function repoxh_url_link($url = '', $link_txt = 'empty', $link_cl = 'empty') {

    global $plugin_cf;

    if($link_txt == 'empty') {
        $first_link_text = substr($url, 0, 11);
        $last_link_text = substr($url, -4);
        $link_text = $first_link_text . ' ... ' . $last_link_text;
    } else {
        $link_text = $link_txt;
    }

    if($link_cl == 'empty') {
        $link_class = ' ';
    } else {
        $link_class = ' class="' . $link_cl . '" ';
    }

    $allowed_down_ext_tmp = trim($plugin_cf['repoxh']['download_extension'], '| ');
    $allowed_down_ext_array = explode('|', $allowed_down_ext_tmp);
    $pos = strrpos($url, '.');
    $down_ext = substr($url, $pos);
    // ist zip, rar, 7z, ...? --> config
    if(in_array($down_ext, $allowed_down_ext_array)) {
        $link = '<a' . $link_class . 'href="' . $url . '">' . $link_text . '</a>';
    } else {
        $link = '<a'
              . $link_class
              . 'target="_blank" rel="noopener noreferrer" href="'
              . $url
              . '">'
              . $link_text
              . '</a>';
    }

return $link;
}
//******************************************************************************
// Datum bearbeiten
function repoxh_input2date($idate = '') {

    // zerlegt die Zeichenkette
    $token = '-./ ';
    $p1 = strtok($idate, $token);
    $p2 = strtok($token);
    $p3 = strtok($token);
    $p4 = strtok($token);
    $date = $y = $m = $d = '';
    // Prüfen der Kombination "d.m.y" (Standard)
    if(($p1 > 0 && $p1 < 32) && ($p2 > 0 && $p2 < 13) && ($p3 > 0)) {
        $y = $p3;
        $m = $p2;
        $d = $p1;
    }
    // alternative Prüfung auf "y.m.d"
    elseif($p1 > 0 && ($p2 > 0 && $p2 < 13) && ($p3 > 0 && $p3 < 32)) {
        $y = $p1;
        $m = $p2;
        $d = $p3;
    }
    //Hinzufügen von 1900 oder 2000 zum Jahr, sollte noch einige Jahre funktionieren
    if($y != '' && $y <= 99) { 
        if($y >= 70) {
            $y = $y + 1900;
        }
        if($y < 70) {
            $y = $y + 2000;
        }
    }
    if($m < 10) {
        $m = str_pad($m, 2, '0', STR_PAD_LEFT);
    }
    if($d < 10) {
        $d = str_pad($d, 2, '0', STR_PAD_LEFT);
    }
    if($y != '') {
        if(checkdate($m, $d, $y)) {
            $date = $y . '-' . $m . '-' . $d;
        }
    }

return $date;
}
//******************************************************************************
// Backlink (Link zurück zur Übersicht)
function repoxh_on_backlink() {

global $plugin_tx;
//frase: p -> div mit Klasse
    $repo_xh_backlink = '<div class="repoXhBacklink"><a href="?'
                      . preg_replace('#&?repo_xh_one=[^&]*#is', '', $_SERVER['QUERY_STRING']) 
                      . '">' . $plugin_tx['repoxh']['one_backlink']
                      . '</a></div>'
                      . "\n";

return $repo_xh_backlink;
}
//******************************************************************************
// Kategorien für InfoSeite
// --> {{{repoxh_cat_infopage('plugin');}}} , {{{repoxh_cat_infopage('template');}}}
function repoxh_cat_infopage($repo_type = '') {

global $plugin_tx;

    $cat_filter = '';
    $repoxh_filter_tmp = trim($plugin_tx['repoxh'][$repo_type . '_cat_filter'], '| ');
    $repoxh_filter_array = explode('|', $repoxh_filter_tmp);
    sort($repoxh_filter_array);
    foreach($repoxh_filter_array as $repoxh_filter_tmp) {
        $repoxh_filter_tmp = trim($repoxh_filter_tmp);
        $repoxh_filter = explode('=', $repoxh_filter_tmp);
        $cat_filter_raw = trim($repoxh_filter[0]);
        $cat_filter .= '<a>' . $cat_filter_raw . '</a>' . "\n";
    }
    unset($repoxh_filter_tmp);

return $cat_filter;
}
//******************************************************************************
// Title für einzelnes Plugin / Template / AddOn
function repoxh_Title($op_tmp_SiteTitel = '') {

    $op_maxtitleLen = 67;

    // Länge begrenzen
    if(strlen(utf8_decode($op_tmp_SiteTitel)) > $op_maxtitleLen) {
        $op_tmp_SiteTitel = substr($op_tmp_SiteTitel, - $op_maxtitleLen);
        // abschneiden bei Pipe
        $op_tmp_SiteTitel = strstr($op_tmp_SiteTitel, '|');
    }
    // wenn erstes Zeichen ein '|', '-', ',', '&', ')' oder ein ' ' dann entfernen
    $op_tmp_SiteTitel = ltrim($op_tmp_SiteTitel, '|-,&) ');
    // wenn letztes Zeichen ein '|', '-', ',', '&', '(' oder ein ' ' dann entfernen
    $op_tmp_SiteTitel = rtrim($op_tmp_SiteTitel, '|-,&( ');

return $op_tmp_SiteTitel;
}
//******************************************************************************
// Description für einzelnes Plugin / Template / AddOn
function repoxh_Description($op_tmpdescription = '') {

    $op_maxDescriptionLen = 156;
    $op_DescExt = " ..." ;

    // ersetzt Break durch Leerzeichen
    $op_tmpdescription = str_ireplace(array('<br>', '<br />', '<li>', '</li>', '"', '„', '“'),
                                      ' ',
                                      $op_tmpdescription);
    //
    $op_tmpdescription = strip_tags($op_tmpdescription);
    // entfernt Leerzeichen und Tabulatoren, vertikaler Tabulatoren,
    //Zeilen- und Seitenvorschub, Wagenrücklauf
    $op_tmpdescription = preg_replace('#[[:space:]]#', ' ', $op_tmpdescription);
    // entfernt nicht druckbare Zeichen
    // (Es gab immer wieder mehrfache "Leezeichen" am Stück, die nicht entfernt wurden)
    $op_tmpdescription = preg_replace('#[^[:print:]]#ums', ' ', $op_tmpdescription);
    // mehrere Leerzeichen auf eins reduzieren
    $op_tmpdescription = preg_replace('#[\s]{2,}#s', ' ', $op_tmpdescription);
    $op_tmpdescription = str_replace(array(' , ', ' . '),
                                     array(', ', '. '),
                                     $op_tmpdescription);
    // mögliche Leerzeichen am Anfang und am Ende entfernen
    $op_tmpdescription = trim($op_tmpdescription);
    if(strlen(utf8_decode($op_tmpdescription)) > $op_maxDescriptionLen) {
        // Länge begrenzen
        $op_tmpdescription = substr($op_tmpdescription, 0, $op_maxDescriptionLen);
        // nach ganzem Wort abschneiden und Punkte anfügen
        $op_tmpdescription = substr($op_tmpdescription, 0, strrpos($op_tmpdescription, ' ')) . $op_DescExt;
    }

return $op_tmpdescription;
}
//******************************************************************************
// SocialMedia-Title für einzelnes Plugin / Template / AddOn
function repoxh_socTitle($title = '') {

global $pth, $hjs;

    if(file_exists($pth['folder']['plugins'] . 'ogra/index.php')) {
        //JSON-LD
        if(strpos($hjs, '"name": "') !== false) {
            $hjs = preg_replace('#"name": "[^"]*"#Uumsi',
                                  '"name": "' . $title . '"', $hjs);
        }
        if(strpos($hjs, '"headline": "') !== false) {
            $hjs = preg_replace('#"headline": "[^"]*"#Uumsi',
                                  '"headline": "' . $title . '"', $hjs);
        }
        //Open Graph
        if(strpos($hjs, 'property="og:title') !== false) {
            $hjs = preg_replace('#\<meta property="og:title" content="[^\>]*\>#Uumsi',
                                  '<meta property="og:title" content="' . $title . '">', $hjs);
        }
        //Twittter
        if(strpos($hjs, 'name="twitter:title') !== false) {
            $hjs = preg_replace('#\<meta name="twitter:title" content="[^\>]*\>#Uumsi',
                                  '<meta name="twitter:title" content="' . $title . '">', $hjs);
        }
    }
}
//******************************************************************************
// SocialMedia-Description für einzelnes Plugin / Template / AddOn
function repoxh_socDesc($description = '') {

global $pth, $hjs;

    if(file_exists($pth['folder']['plugins'] . 'ogra/index.php')) {
        //JSON-LD
        if(strpos($hjs, '"description": "') !== false) {
            $hjs = preg_replace('#"description": "[^"]*"#Uumsi',
                                  '"description": "' . $description . '"', $hjs);
        }
        //Open Graph
        if(strpos($hjs, 'property="og:description') !== false) {
            $hjs = preg_replace('#\<meta property="og:description" content="[^\>]*\>#Uumsi',
                                  '<meta property="og:description" content="' . $description . '">', $hjs);
        }
        //Twittter
        if(strpos($hjs, 'name="twitter:description') !== false) {
            $hjs = preg_replace('#\<meta name="twitter:description" content="[^\>]*\>#Uumsi',
                                  '<meta name="twitter:description" content="' . $description . '">', $hjs);
        }
    }
}
//******************************************************************************
// SocialMedia-timestamp für einzelnes Plugin / Template / AddOn
function repoxh_socTimestamp($last_updated = '') {

global $pth, $hjs;

    if(file_exists($pth['folder']['plugins'] . 'ogra/index.php')) {
        //JSON-LD
        if(strpos($hjs, '"dateModified": "') !== false) {
            $hjs = preg_replace('#"dateModified": "[^T]*T#Uumsi',
                                  '"dateModified": "' . $last_updated . 'T', $hjs);
        }
        //Open Graph
        if(strpos($hjs, 'property="og:updated_time') !== false) {
            $hjs = preg_replace('#\<meta property="og:updated_time" content="[^T]*T#Uumsi',
                                  '<meta property="og:updated_time" content="' . $last_updated . 'T', $hjs);
        }
    }
}
//******************************************************************************