<?php
/* utf8-marker = äöüß */

/*
 * Repo_XH
 *
 * @author  Olaf Penschke    olape
 * @version 1.0 beta3 (30.04.2020)
 * @link    http://olaf.penschke.net/

 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3

================================================================================
*/
//******************************************************************************
if('xml2csv.php' == basename($_SERVER['SCRIPT_FILENAME']))
{
    include_once(__DIR__ . '/config/config.php');
    include_once(__DIR__ . '/languages/en.php');
}

// config
    $op_maxdirs = $plugin_cf['repoxh']['curlopt_maxredirs'];
    settype($op_maxdirs, "integer");

    $op_connecttimeout = $plugin_cf['repoxh']['curlopt_connecttimeout'];
    settype($op_connecttimeout, "integer");

    $op_timeout = $plugin_cf['repoxh']['curlopt_timeout'];
    settype($op_timeout, "integer");

    if($plugin_cf['repoxh']['curlopt_ssl_verifyhost'] == 'on') {
        $op_ssl_verifyhost = 2;
    } else {
        $op_ssl_verifyhost = false;
    }

//******************************************************************************
// Sammeln der Informationen und Erstellen der csv + Caching 
// --> Cachetime, falls genutzt länger als Intervall des Cronjob einstellen
// --> per Cronjob ausführen 
// curl -s 'http://domain.tld/plugins/repoxh/xml2csv.php?repo_type=plugin&repo_client=cronjob&repo_key=0815'
// curl -s 'http://domain.tld/plugins/repoxh/xml2csv.php?repo_type=template&repo_client=cronjob&repo_key=0815'
//
// alternativ
// curl -s 'http://domain.tld/plugins/repoxh/xml2csv.php?repo_type=all&repo_client=cronjob&repo_key=0815'

if((isset($_GET['repo_type']))
    && (isset($_GET['repo_client']))
    && (isset($_GET['repo_key']))
    && ($_GET['repo_key'] == $plugin_cf['repoxh']['secret_key'])) {
        if($_GET['repo_type'] == 'all') {
        $op_allfiles = scandir('./source/');
            foreach($op_allfiles as $op_file_tmp) {
                if(($op_file_tmp != '.')
                && ($op_file_tmp != '..')
                && ($op_file_tmp != '.htaccess')
                && (substr($op_file_tmp, -4) != '.bak')) {
                    $repo_type_tmp = substr($op_file_tmp, 0, -4);
                    xml2csv($repo_type_tmp, $_GET['repo_client']);
                }
            }
        } else {
            xml2csv($_GET['repo_type'], $_GET['repo_client']);
        }
}
//******************************************************************************
// Beginn Zieldatei erstellen wenn nicht vorhanden
function xml2csv($repo_type = '', $repo_client = '') {

    global $plugin_tx, $plugin_cf;

    $xml_source_dat = './source/' . $repo_type . '.dat';
    $target_temp_csv = './target/' . $repo_type . '.tmp';
    $target_csv = './target/' . $repo_type . '.csv';
    $target_lock = './target/' . $repo_type . '.lock';
    $img_tmp = './img_tmp/' . $repo_type;

    if($repo_client == 'cronjob') {
        $output_tmp = date(DATE_RFC2822) . "\n";
        $output_log = './cronlogs/' . $repo_type . '.log';
        echo $output_tmp;
        // logs aus php, da nicht überall direkt von Cronjobs möglich
        file_put_contents($output_log, $output_tmp, FILE_APPEND);
    } else {
        echo '<p>' . $repo_type . ' - ' . $plugin_tx['repoxh']['xml2csv_message'] . '</p>';
    }

    if(file_exists($xml_source_dat)) {

        // vorhanden Bilderordner löschen
        if(file_exists($target_csv)) {
            // Lock setzen
            $fp = fopen($target_lock, 'w');
            fputs($fp, date(DATE_RFC2822) . "\n");
            fclose($fp);
            //sleep(20); // tmp
            if(is_dir($img_tmp)) {
                repoxh_rrmdir($img_tmp);
                mkdir($img_tmp, 0777);
            }
            //sleep(20); // tmp
        }
//
        // csv mit URLs zu xml-Dateien
        $xml_files = file($xml_source_dat);
//
        // sortiert nach der zweiten "Spalte" --> Pluginname
        usort($xml_files, function($a,$b) {
            //return strcmp(substr($a, strpos($a, '|')), substr($b, strpos($b, '|')));
            return strcasecmp(substr($a, strpos($a, '|')), substr($b, strpos($b, '|')));
            }
        );
//
// $plugin_counter für Zieldatei --> ersetzt durch fortlaufende ID aus Quelle
        foreach($xml_files as $plugin_counter => $file) {
//
            // Time Limit für jeden Durchlauf neu setzen
            set_time_limit(30);
            $file = trim($file);
            $file = explode('|', $file);
//
            $xml_id = $file[0];
            $xml_name = $file[1];
            $xml_url = $file[2];
//
            // erfordert allow_url_fopen = On --> cURL nutzen
            //$xml = simplexml_load_file($xml_url) or die('');
            // xml einlesen
            $xml_tmp = repoxh_curl($xml_url);
            //echo $xml_url . '<br>'; // Testausgabe
            //echo $xml_tmp . '<br>'; // Testausgabe
            if($xml_tmp != 'error') {
            //echo $xml_tmp; // Testausgabe
//
                // sha256 hash des xml-Strings
                $sha256new = hash('sha256', $xml_tmp);
//
                $target_id_file = './sha256/' . $repo_type . '/' . $xml_id;
                $sha256old = 'empty';
                // vorhergehender sha256 hash des xml-Strings auslesen
                if(file_exists($target_id_file)) {
                    $fp = fopen($target_id_file, 'r');
                    $sha256old = fgets($fp, 1024);
                    fclose($fp);
                }
//
                // sha256 Vergleich beim Reload
                if(($sha256old != 'empty') && ($sha256new != $sha256old)) {
                    $target_change_file = './changes/' . $repo_type . '_change.log';
                    $fp = fopen($target_change_file, 'a+');
                    fputs($fp, $xml_id . ' - ' . $xml_name . ' - ' . date(DATE_RFC2822) . "\n");
                    fclose($fp);
                }
//
                // sha256 hash des xml-Strings in Datei schgreiben
                $fp = fopen($target_id_file, 'w');
                fputs($fp, $sha256new);
                fclose($fp);
//
                // br, ol, ul, li, b, i <> & durch Entities ersetzen
                $xml_tmp = str_replace(array('&', 
                                             '<br>', 
                                             '<br/>', 
                                             '<ol>', 
                                             '</ol>', 
                                             '<ul>', 
                                             '</ul>', 
                                             '<li>' , 
                                             '</li>', 
                                             '<i>', 
                                             '</i>', 
                                             '<b>', 
                                             '</b>'
                                        ), 
                                       array('&amp;', 
                                             '&lt;br&gt;', 
                                             '&lt;br/&gt;', 
                                             '&lt;ol&gt;', 
                                             '&lt;/ol&gt;', 
                                             '&lt;ul&gt;', 
                                             '&lt;/ul&gt;', 
                                             '&lt;li&gt;', 
                                             '&lt;/li&gt;', 
                                             '&lt;i&gt;', 
                                             '&lt;/i&gt;', 
                                             '&lt;b&gt;', 
                                             '&lt;/b&gt;'
                                        ), 
                $xml_tmp);
                //echo $xml_tmp; // Testausgabe
                $allowed_xml_version_tmp = trim($plugin_cf['repoxh']['xml_version'], '| ');
                $allowed_xml_version = explode('|', $allowed_xml_version_tmp);
                libxml_use_internal_errors(true);
                $xml = simplexml_load_string($xml_tmp);
                // Prüfen, ob Inhalt fehlerfrei geladen und xml-Version stimmt
                //if(($xml !== false) && ($xml->attributes() == '1.0')) {
                if(($xml !== false) && (in_array($xml->attributes(), $allowed_xml_version))) {
                    //echo $xml_id . ' - ' . $xml->attributes() . ' - ' . $xml->name->attributes(); // Testausgabe
                    // Wenn Version grösser als 1.0, Attribut von name vergleichen
                    if((($xml->attributes() >= 1.1) && ($xml->name->attributes() == $repo_type)) || ($xml->attributes() == 1.0)) {
//
                        /*echo '<p><b>Testausgabe direkt aus externer xml</b></p>' . "\n"; // Testausgabe
                        echo $xml_url . '<br><br>' . "\n";
                        echo 'Plugin: ' . $xml->name . '<br>' . "\n";
                        echo 'Informationen aktualisiert am: ' . $xml->date_update . '<br>' . "\n";
                        echo 'aktuelle Version: ' . $xml->version . '<br>' . "\n";
                        echo 'Datum der Veröffentlichung: ' . $xml->date_version . '<br>' . "\n";
                        echo 'Programmierer: ' . $xml->coder . '<br>' . "\n";
                        echo 'Kategorie: ' . $xml->tags . '<br>' . "\n";
                        echo 'Download-URL: ' . $xml->url->download_url . '<br>' . "\n";
                        echo 'Website: ' . $xml->url->coder_url . '<br>' . "\n";
                        echo 'Demo-URL: ' . $xml->url->demo_url . '<br>' . "\n";
                        echo 'Kompatibilität: ' . $xml->compatibility . '<br>' . "\n";
                        echo 'PHP-Version: ' . $xml->php_ver . '<br>' . "\n";
                        echo 'Lizenz: ' . $xml->license . '<br>' . "\n";
                        //echo 'Description: ' . $xml->description->description_en . '<br>' . "\n";
                        //echo 'Beschreibung: ' . $xml->description->description_de . '<br><br>' . "\n";
                        echo 'Logo: ' . $xml->logo . '<br>' . "\n";
                        echo $xml->attributes();*/
//
                        // Array für target.csv erstellen
                        $csv_array = array(
                            //$plugin_counter, // $plugin_counter für Zieldatei --> ersetzt durch fortlaufende ID aus Quelle
                            $xml_id, 
                            $xml->name, 
                            $xml->date_update, 
                            $xml->version, 
                            $xml->date_version, 
                            $xml->coder, 
                            $xml->tags, 
                            $xml->url->download_url, 
                            $xml->url->coder_url, 
                            $xml->url->demo_url, 
                            $xml->compatibility, 
                            $xml->php_ver, 
                            $xml->license
                        );
//
                        // Prüfen ob img-Verzeichnis vorhanden ist
                        if(!is_dir($img_tmp)) {
                            mkdir($img_tmp, 0777);
                        }
//
                        // Namen für Bilderordner (Icon und Screenshots) erstellen
                        $img_folder = $xml_id;
                        mkdir($img_tmp . '/' . $img_folder, 0777);
                        $full_img_folder = $img_tmp . '/' . $img_folder;
//
// beginnt mit http?
                        if(($xml->logo != '') && (substr($xml->logo, 0, 4) == 'http')) {
                            //
                            $allowed_logo_ext_tmp = trim($plugin_cf['repoxh']['logo_extension'], '| ');
                            $allowed_logo_ext_array = explode('|', $allowed_logo_ext_tmp);
                            $pos = strrpos($xml->logo, '.');
                            $logo_ext = substr($xml->logo, $pos);
                            //
                            // ist gif, jpg, png, ...? -_> config
                            if(in_array($logo_ext, $allowed_logo_ext_array)) {
                                // Bild einlesen
                                $logo_raw = repoxh_curl($xml->logo);
                                if($logo_raw != 'error') {
                                    // Daten in Cachefile schreiben
                                    $plugin_logo = fopen($full_img_folder . '/logo' . $logo_ext, 'w+');
                                    fwrite($plugin_logo, $logo_raw);
                                    fclose($plugin_logo);
                                    // ist Bild im Cache vorhanden?
                                    if(file_exists($full_img_folder . '/logo' . $logo_ext)) {
                                        // Logo in csv eintragen, Position 13 in Array
                                        $csv_array[] = 'logo' . $logo_ext;
                                    } else {
                                        $csv_array[] = ' ';
                                    }
                                } else {
                                    $csv_array[] = ' ';
                                }
                            } else {
                                $csv_array[] = ' ';
                            }
                        } else {
                            $csv_array[] = ' ';
                        }
//
                        // Wenn Vorlage noch 1.0
                        if($xml->attributes() == '1.0') {
                            $desc_lang = $xml->xpath('/plugin/descriptions/description');
                        } else {
                            $desc_lang = $xml->xpath('/teplad/descriptions/description');
                        }
                        // Sprachen auslesen, ab Position 14 im Array
                        foreach($desc_lang as $description_count => $desc_language) {
                            $desc_att_lang = $xml->descriptions->description[$description_count]->attributes();
                            $csv_array[] = '|||||' . $desc_att_lang . '|||||' . $desc_language;
                        }
                        unset($description_count);
                        unset($desc_language);
//
                        // Wenn Vorlage noch 1.0
                        if($xml->attributes() == '1.0') {
                            $screen_shots = $xml->xpath('/plugin/screenshots/screenshot');
                        } else {
                            $screen_shots = $xml->xpath('/teplad/screenshots/screenshot');
                        }
                        // Screenshots auslesen, ab Position xx im Array
                        foreach($screen_shots as $screenshot_count => $screen_shot) {
                            $screen_att_view = $xml->screenshots->screenshot[$screenshot_count]->attributes();
                            // beginnt mit http?
                            if(($screen_shot != '') && (substr($screen_shot, 0, 4) == 'http')) {
                                //
                                $allowed_screen_ext_tmp = trim($plugin_cf['repoxh']['screen_extension'], '| ');
                                $allowed_screen_ext_array = explode('|', $allowed_screen_ext_tmp);
                                $pos = strrpos($screen_shot, '.');
                                $screen_ext = substr($screen_shot, $pos);
                                //
                                // ist jpg, jpeg, png, ...? --> config, Anzahl erlaubter Screenshots
                                if((in_array($screen_ext, $allowed_screen_ext_array))
                                && ($screenshot_count <= ($plugin_cf['repoxh']['screen_number_of'] - 1))) {
                                    // Bild einlesen
                                    $screen_raw = repoxh_curl($screen_shot);
                                    if($screen_raw != 'error') {
                                        // Daten in Cachefile schreiben
                                        $plugin_screen = fopen($full_img_folder . '/screenshot_' . $screenshot_count . $screen_ext, 'w+');
                                        fwrite($plugin_screen, $screen_raw);
                                        fclose($plugin_screen);
                                        // ist Bild im Cache vorhanden?
                                        if(file_exists($full_img_folder . '/screenshot_' . $screenshot_count . $screen_ext)) {
                                            $csv_array[] = '|||||screenshot|||||'
                                                         . 'screenshot_'
                                                         . $screenshot_count
                                                         . $screen_ext
                                                         . '#####'
                                                         . $screen_att_view;
                                        } else {
                                            $csv_array[] = ' ';
                                        }
                                    } else {
                                        $csv_array[] = ' ';
                                    }
                                } else {
                                    $csv_array[] = ' ';
                                }
                            } else {
                                $csv_array[] = ' ';
                            }
                        }
                        unset($screenshot_count);
                        unset($screen_shot);
//
                        $csv_array_clear = [];
                        foreach($csv_array as $csv_array_tmp) {
                            // html-Tags entfernen ausser <br><ul><ol><li><b><i>
                            $csv_array_tmp = strip_tags(html_entity_decode($csv_array_tmp, ENT_QUOTES, 'UTF-8'), '<br><ul><ol><li><b><i>');
                            // entfernt Leerzeichen und Tabulatoren, vertikaler Tabulatoren, Zeilen- und Seitenvorschub, Wagenrücklauf
                            $csv_array_tmp = preg_replace('#[[:space:]]#', ' ', $csv_array_tmp);
                            // entfernt nicht druckbare Zeichen (Es gab immer wieder mehrfache "Leezeichen" am Stück, die nicht entfernt wurden)
                            $csv_array_tmp = preg_replace('#[^[:print:]]#ums', ' ', $csv_array_tmp);
                            // mehrere Leerzeichen auf eins reduzieren
                            $csv_array_tmp = preg_replace('#[\s]{2,}#s', ' ', $csv_array_tmp);
                            // mögliche Leerzeichen am Anfang und am Ende entfernen
                            $csv_array_tmp = trim($csv_array_tmp);
                            $csv_array_tmp = rtrim($csv_array_tmp, ',');
                            $csv_array_clear[] = $csv_array_tmp;
                        }
                        unset($csv_array_tmp);
//
                        // in target.csv schreiben
                        $fp = fopen($target_temp_csv, 'a+');
                        fputcsv($fp, $csv_array_clear);
                        fclose($fp);
                    }
                }/* else { // Testausgabe libxml error
                echo 'Laden des XML fehlgeschlagen - ' . $xml_name;
                foreach(libxml_get_errors() as $error) {
                    echo "\t", $error->message . '<br>' . "\n";
                }
                libxml_clear_errors();
                }*/
            }
        }
        unset($plugin_counter);
        unset($file);
        //sleep(20);  // tmp
        // vorhanden Sicherung löschen
        if(file_exists($target_csv . '.bak')) {
            unlink($target_csv . '.bak');
        }
        // vorhanden Zeildatei umbenennen
        if(file_exists($target_csv)) {
            rename($target_csv, $target_csv . '.bak');
        }
        // temp. Zieldatei umbenennen
        if(file_exists($target_temp_csv)) {
            rename($target_temp_csv, $target_csv);
        }
    }
    // Lock entfernen
    if(file_exists($target_lock)) {
        unlink($target_lock);
    } 
}

//******************************************************************************
// Verzeichnis rekursiv löschen
function repoxh_rrmdir($src) {
    $dir = opendir($src);
    while(false !== ($file = readdir($dir))) {
        if(($file != '.') && ($file != '..')) {
            $full = $src . '/' . $file;
            if(is_dir($full)) {
                repoxh_rrmdir($full);
            } else {
                unlink($full);
            }
        }
    }
    closedir($dir);
    rmdir($src);
}

//******************************************************************************
// externe Inhalte laden
function repoxh_curl($curl_url = '') {

    global $op_maxdirs, $op_connecttimeout, $op_timeout, $op_ssl_verifyhost;

    $curl = curl_init(trim($curl_url));
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($curl, CURLOPT_MAXREDIRS, $op_maxdirs);
    curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, $op_connecttimeout);
    curl_setopt($curl, CURLOPT_TIMEOUT, $op_timeout);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, $op_ssl_verifyhost);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
    $repo_xh_curl_tmp = curl_exec($curl);
    $httpCode = curl_getinfo($curl, CURLINFO_RESPONSE_CODE);
    //echo $curl_url . ' - ' . $httpCode; // Testausgabe
    if(($repo_xh_curl_tmp === false) || ($httpCode !== 200)) {
        $repo_xh_curl_tmp = 'error';
        //echo ' - ' . $repo_xh_curl_tmp . '<br>'; // Testausgabe
    }
    curl_close($curl);

return $repo_xh_curl_tmp;
}
//******************************************************************************
?>